<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api } from "~/common/constaint";
import _ from "lodash";
import { getTimeZone, getUnixFrom, getUnixTo } from "~/utils/timeZone";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({
  components: {
    List: () => import("./List/index.vue"),
  },
})
export default class AdminAnalyticsComponent extends Vue {
  tab = 0;

  dateStartPicker = false;
  dateEndPicker = false;
  dateStart = momentz().startOf("month").format("YYYY-MM-DD");
  dateEnd = moment().endOf("day").format("YYYY-MM-DD");

  datePicker = false;
  isAbandonedMail = false;

  get dateArr() {
    return this.$store.state.setting?.dateArr || [];
  }

  set dateArr(value: string[]) {
    this.$store.commit("setting/setDateArr", value);
  }

  config = {
    // page: 1,
    // limit: 100,
    // search: "",
  };
  totalPage: number = 0;
  page = 1;

  listDate: any = [];
  listDomain: any = [];
  listProduct: any = [];
  listSeller: any = [];
  loadingTable = false;
  loadingTableUtm = false;
  loadingTableDomain = false;
  loadingTableProduct = false;
  loadingTableSeller = false;

  get timeActive() {
    return this.$store.state.setting.timeActive;
  }

  set timeActive(value: string) {
    this.$store.commit("setting/setTimeActive", value);
  }

  get timezone() {
    return this.$store.state.setting.timezone;
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  get dateRangeText() {
    return this.dateArr.join("~");
  }

  mounted() {
    this.timeActive = "Today";
    this.$store.commit("setting/setTime", {
      dateStart: this.dateRangeText.split("~")[0],
      dateEnd: this.dateRangeText.split("~")[1],
    });
    // this.onCheckTabGetList();
    this.onFilterByTime("Today");
  }

  onCheckTabGetList() {
    this.listDate = [];
    this.listDomain = [];
    this.listProduct = [];
    this.listSeller = [];
    if (this.tab === 0) {
      this.onGetListUTM();
    } else if (this.tab === 1) {
      this.config = {
        // page: 1,
        // limit: 100,
        // search: "",
      };
      this.onGetListDomain();
    } else if (this.tab === 2) {
      this.onGetListProduct();
    } else {
      this.onGetListSeller();
    }
  }

  async onGetListUTM() {
    try {
      this.loadingTableUtm = true;
      let response = [];

      if (this.isAbandonedMail) {
        response = await this.$api.stats.getListUtmAbandon({
          from: this.from,
          to: this.to,
          timezone: this.timezone,
        });
      } else {
        response = await this.$api.stats.getListUtm({
          from: this.from,
          to: this.to,
          timezone: this.timezone,
        });
      }

      if (response?.data) {
        this.listDate = response.data;
        for (let item of response.data) {
          item["pcre"] =
            item.revenue == 0 ? 0 : item.productCost / item.revenue;
        }

        const elemLast = this.parseElementLast(this.listDate);
        // conversionRate = conversionRate / response.data.length;
        // pcre = pcre / response.data.length;
        this.listDate.push(elemLast);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTableUtm = false;
    }
  }

  async onGetListDomain() {
    try {
      this.loadingTableDomain = true;
      let response = [];
      if (this.isAbandonedMail) {
        response = await this.$api.stats.getListDomainAbandon({
          ...this.config,
          from: this.from,
          to: this.to,
          timezone: this.timezone,
        });
      } else {
        response = await this.$api.stats.getListDomain({
          ...this.config,
          from: this.from,
          to: this.to,
          timezone: this.timezone,
        });
      }
      if (response?.data) {
        for (let item of response.data) {
          if (item.revenueTotal === undefined) {
            item.revenueTotal = item.revenue;
          }
        }
        this.listDomain = response.data;
        const elemLast = this.parseElementLast(this.listDomain);
        this.listDomain.push(elemLast);

        console.log("this.listDomain :>> ", this.listDomain);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTableDomain = false;
    }
  }

  async onGetListProduct() {
    try {
      this.loadingTableProduct = true;
      let response = [];
      if (this.isAbandonedMail) {
        response = await this.$api.stats.getListProductAbandon({
          ...this.config,
          from: this.from,
          to: this.to,
          timezone: this.timezone,
        });
      } else {
        response = await this.$api.stats.getListProduct({
          ...this.config,
          from: this.from,
          to: this.to,
          timezone: this.timezone,
        });
      }
      if (response?.data) {
        for (let item of response.data) {
          if (item.revenueTotal === undefined) {
            item.revenueTotal = item.revenue;
          }
        }
        this.listProduct = response.data;

        const elemLast = this.parseElementLast(this.listProduct);
        this.listProduct.push(elemLast);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTableProduct = false;
    }
  }

  async onGetListSeller() {
    try {
      this.loadingTableSeller = true;
      let response = [];
      if (this.isAbandonedMail) {
        response = await this.$api.stats.getListSellerAbandon({
          ...this.config,
          from: this.from,
          to: this.to,
          timezone: this.timezone,
        });
      } else {
        response = await this.$api.stats.getListSeller({
          ...this.config,
          from: this.from,
          to: this.to,
          timezone: this.timezone,
        });
      }
      if (response?.data) {
        for (let item of response.data) {
          if (item.revenueTotal === undefined) {
            item.revenueTotal = item.revenue;
          }
        }
        this.listSeller = response.data;

        const elemLast = this.parseElementLast(this.listSeller);
        this.listSeller.push(elemLast);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTableSeller = false;
    }
  }

  parseElementLast(list: any) {
    let addToCart = 0;
    let checkout = 0;
    let productCost = 0;
    let purchase = 0;
    let quantity = 0;
    let revenue = 0;
    let revenueTotal = 0;
    let refund = 0;
    let tip = 0;
    let goCheckout = 0;
    // let conversionRate = 0;
    // let viewContent = 0;
    // let addToCart = 0;
    // let initiateCheckout = 0;
    // let pcre = 0;
    for (let item of list) {
      // conversionRate += item.conversionRate;
      // viewContent += item.viewContent;
      // addToCart += item.addToCart;
      // initiateCheckout += item.initiateCheckout;
      purchase += item.purchase;
      revenue += item.revenue;
      revenueTotal += item.revenueTotal;
      productCost += item.productCost;
      // pcre += item.revenue == 0 ? 0 : item.productCost / item.revenue;
      refund += item.revenueTotal - item.revenue;
      addToCart += item.addToCart;
      checkout += item.checkout;
      tip += item.tip;
      goCheckout += item.goCheckout;
    }

    return {
      purchase,
      revenue,
      revenueTotal,
      productCost,
      refund,
      addToCart,
      checkout,
      tip,
      goCheckout,
    };
  }

  onRedirectPage() {
    // this.config.page = this.page;
    // this.onGetListDomain();
  }

  onHandleSearch() {
    this.$store.commit("setting/setTime", {
      dateStart: this.dateRangeText.split("~")[0],
      dateEnd: this.dateRangeText.split("~")[1],
    });
    this.onCheckTabGetList();
    this.timeActive = "";
  }

  onFilterByTime(time: string) {
    this.$store.commit("setting/setFilterByTime", { time });
    this.onCheckTabGetList();
  }

  @Watch("config.page")
  changePage() {
    this.onGetListDomain();
  }

  @Watch("tab")
  changedTab() {
    this.onCheckTabGetList();
  }

  @Watch("isAbandonedMail")
  changedAbandoneMail() {
    this.onCheckTabGetList();
  }
}
</script>

<style lang="scss">
.filter-btn {
  @media (max-width: 640px) {
    margin-left: auto;
  }
}

#hideBottomInput .checkbox-isAbandoned .v-input__control .v-input__slot label {
  color: black;
}
</style>
